#!/usr/bin/env python3

R = 43
S = 22
M = 2**32

def random(randomstate):
    global carry
    while len(X) <= randomstate:
        i = len(X)
        current = (X[i-S] - X[i-R] - carry)
        carry = 1 if current < 0 else 0
        X.append(current % M)
    return X[randomstate]

def move(F, randomstate, right):
    pts = 0
    newF = []
    merged = False
    for tile in (reversed(F) if right else F):
        if tile == 0:
            continue
        if newF and newF[-1] == tile and not merged:
            pts += tile + tile
            newF[-1] = tile + tile
            merged = True
        else:
            newF.append(tile)
            merged = False
    num_full = len(newF)
    num_empty = len(F) - len(newF)
    newF.extend([0] * num_empty)
    if right:
        newF.reverse()

    if F != tuple(newF):
        pos = random(randomstate) % num_empty
        randomstate += 1
        new_value = 4 if random(randomstate) % 10 == 0 else 2
        randomstate += 1
        newF[pos + (0 if right else num_full)] = new_value

    return tuple(newF), randomstate, pts

def get(F, randomstate):
    if (F, randomstate) in results:
        return results[(F, randomstate)]

    lF, lrs, lpts = move(F, randomstate, False)
    rF, rrs, rpts = move(F, randomstate, True)
    best = 0
    if lF != F or lpts: best = max(best, lpts + get(lF, lrs))
    if rF != F or rpts: best = max(best, rpts + get(rF, rrs))

    results[(F, randomstate)] = best
    return best

T = int(input())
for _ in range(T):
    carry = 0
    input()   # ignore empty line
    input()   # ignore N
    F = tuple(map(int, input().split()))
    X = list(map(int, input().split()))
    randomstate = len(X)

    results = {}
    print(get(F, randomstate))
